package physbeans.editors;

import java.beans.*;

/**
 * Property editor for associativity type of ArithmeticFunction using a
 * dropdown list.
 * <P>Associativity is given by order of the three op's, so by a permutation.
 * Since the two permutations 312 and 132 give the same associativity,
 *    there are 5 different schemes:
 *      scheme                      ops    nr
 *    ((a op b) op c) op d          123    0
 *    (a op b) op (c op d)       132/312   1
 *    (a op (b op c)) op d          213    2
 *    a op ((b op c) op d)          231    3
 *    a op (b op (c op d))          321    4
 */
public class ArithmeticFunctionAssociativityEditor extends TaggedEditor {
  
  public ArithmeticFunctionAssociativityEditor() {
    types = new String[] { "((a op b) op c) op d ",
        "(a op b) op (c op d)",
        "(a op (b op c)) op d",
        "a op ((b op c) op d)",
        "a op (b op (c op d)) "
    };
  }
}
